;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: name-of-fun -*-
#|
Copyright (C) ISST - Fraunhofer Institute for Software Engineering and Systems 
Engineering - Berlin 1994


-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    name-of-fun.em
Version: 1.0 (last modification on Fri May 28 13:12:11 1993)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /tmp_mnt/home/saturn/akind/Lisp/Apply/name-of-fun.em[1.0]
	Mon May 31 20:05:31 1993 hfried@isst proposed $
 

-----------------------------------------------------------------------------------
|#

#module name-of-fun

(import (eulisp1
         accessors
         lzs 
         mzs 
         )

 syntax (eulisp1)

 export (name-of funtype-of)

 )



(defgeneric name-of (fun))

(defmethod name-of ((fun <slot-accessor-fun>))
  (?identifier (?slot fun)))

(defmethod name-of ((fun <slot-init-fun>))
  (?identifier (?slot fun)))

(defmethod name-of ((fun <constructor-fun>))
  (?identifier (?constructor-for fun)))

(defmethod name-of (fun)
  (?identifier fun))

(defgeneric funtype-of (fun))

(defmethod funtype-of ((fun <slot-accessor-fun>))
  "slot-accessor")

(defmethod funtype-of ((fun <slot-init-fun>))
  "slot-init")

(defmethod funtype-of ((fun <constructor-fun>))
  "constructor")

(defmethod funtype-of ((fun <global-fun>))
  "global")

(defmethod funtype-of ((fun <global-generic-fun>))
  "global generic")

(defmethod funtype-of ((fun <local-fun>))
  "local")

(defmethod funtype-of ((fun <imported-fun>))
  "extern")


#module-end