;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: setq-form -*-
#|
Copyright (C) ISST - Fraunhofer Institute for Software Engineering and Systems 
Engineering - Berlin 1994


-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    setq-form.em
Version: 2.0 (last modification on Thu Mar  3 15:33:21 1994)
State:   proposed

DESCRIPTION:

DOCUMENTATION:

NOTES:

REQUIRES:

PROBLEMS:

AUTHOR: Dr. Horst Firedrich

CONTACT: horst.friedrich@isst.fhg.de

HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/setq-form.em[2.0]:
  text
[1.1] Thu Mar 18 09:01:54 1993 hfried@isst proposed
  [Fri Mar  5 13:05:31 1993] Intention for change:
[1.2] Wed Mar 24 13:50:35 1993 hfried@isst proposed
  [Thu Mar 18 09:13:53 1993] Intention for change:
[1.3] Wed Mar 24 17:48:21 1993 hfried@isst proposed
  add: setq global-static
[1.4] Thu Mar 25 11:21:45 1993 hfried@isst proposed
  [Wed Mar 24 17:50:59 1993] Intention for change:
  new head
[1.5] Tue Apr 13 14:11:09 1993 hfried@isst proposed
  [Thu Mar 25 11:55:12 1993] Intention for change:
[1.6] Fri Apr 16 15:08:12 1993 hfried@isst proposed
  [Tue Apr 13 14:17:00 1993] Intention for change:
  error (value of set-form) removed
[1.7] Mon Jun 21 11:49:07 1993 hfried@isst saved
  [Fri Apr 16 15:09:33 1993] Intention for change:
[1.8] Wed Aug 18 11:47:56 1993 hfried@isst proposed
  [Tue Aug 10 09:13:47 1993] Intention for change:
  typen in add-move
[1.9] Tue Sep  7 07:59:33 1993 hfried@isst published
  [Mon Sep  6 09:16:08 1993] Intention for change:
  defined-named-const
[1.10] Thu Mar  3 11:14:16 1994 hfried@isst proposed
  [Mon Feb 14 14:54:34 1994] Intention for change:
  handle local-static-variables
[1.11] Fri Mar  4 11:35:46 1994 wheick@isst proposed
  [Thu Mar  3 15:08:49 1994] Intention for change:
  insert eulisp0,1
  done
[2.0] Fri Mar  4 11:35:46 1994 wheick@isst proposed
  [Thu Mar  3 15:08:49 1994] Intention for change:
  insert eulisp0,1
  done

-----------------------------------------------------------------------------------
|#

#module setq-form

(import 
 (eulisp1 
  context
  LZS
  analyse-h
  MZS 
  move
  gutter
  accessors
  ) 
 
 syntax 
 (eulisp1 
  simple-programming)
 
 export 
 (setq-form-a) ; con, form 
 )


;--- definitions, exportations, initialization forms


;;;    ###########
(defun setq-form-a (con form)
;;;    ###########
  (let ((location (?location form)))
    (setq-form1 
     (if (var-ref-p location) (?var location) location) 
     (l2m-a (dynamic *arg-context*) (?form form))
     (?write-gloc form)
     (let ((rgloc (?read-gloc form)))
       (if rgloc
         (if (consp rgloc) rgloc (list rgloc))
         ()))))
  )


(defgeneric setq-form1 (var res rgloc wglocs))

(defmethod setq-form1 ((con <named-const>) res rgloc wglocs)
  (add-move1 con res () (if rgloc (list rgloc) ()) wglocs)
  res)

(defmethod setq-form1 ((var <local-static>) (res <tempvar>) rgloc wglocs)
  (if (?closure var) 
    (progn (set-closure-var var res (dynamic block)) res) 
; subst tempvar by local-static 
    (let* ((link (?link res))
	   (stat (car (car link)))
	   (newlocal (make <local-static> :identifier (?identifier var)
			  :link (?link res))))
      (setf (vector-ref (?var-vec (?var-descr stat)) 0) newlocal)
      (add-env var newlocal)
      newlocal))
)

(defmethod setq-form1 ((var <local-static>) res rgloc wglocs)
  (if (?closure var) 
    (progn 
      (set-closure-var var res (dynamic block))
      res)
    (let ((tmpvar (make <tempvar> :tnr (a-number))))
      (add-move1 tmpvar res () (if rgloc (list rgloc) ()) wglocs)
      (add-env var tmpvar)
      tmpvar))
)

(defmethod setq-form1 ((var <dynamic>) res rgloc wglocs)
  (add-move1 var res () (if rgloc (list rgloc) ()) wglocs)
  res
)

(defmethod setq-form1 ((var <global-static>) res rgloc wglocs)
  (add-move1 var res () (if rgloc (list rgloc) ()) wglocs)
  res
)

(defmethod setq-form1 ((var <imported-static>) res rgloc wglocs)
  (add-move1 var res () (if rgloc (list rgloc) ()) wglocs)
  res
)

#module-end
